// =============================================================================
// Framework unit
// =============================================================================
// NWN Faerun Framework (c) 2024 by Julien Lecomte
// SPDX-License-Identifier: MIT
//
// This file is part of the Faerun Framework:
//   https://framework.faerun.pw

/*! rst
Send feedback on OnFailToOpen event.

Variables
~~~~~~~~~

:ev:`NW_L_FEEDBACK`: *(int)* Set to value to use from :file:`nw_all_feedback`

Scripts
~~~~~~~

:ev:`OnFailToOpen`: :file:`fw_event`

*/

#include "fi_events"


// =============================================================================
void main()
{
  int nEvent = GetEvent();

  if (nEvent != EVENT_OBJECT_FAIL_TO_OPEN)
    return;

  if (!GetLocalInt(OBJECT_SELF, NW_L_FEEDBACK))
    return;

  object oPC = GetClickingObject();
  if (!GetIsPC(oPC))
    return;

  // Prevent showing this when distance is far away
  float fDist = GetDistanceBetween(oPC, OBJECT_SELF);
  if (fDist > 3.0f)
    return;

  SpeakOneLinerConversation("nw_all_feedback");
}
