// =============================================================================
// Framework User-Defined placeable
// =============================================================================
// NWN Faerun Framework (c) 2024 by Julien Lecomte
// SPDX-License-Identifier: MIT
//
// This file is part of the Faerun Framework:
//   https://framework.faerun.pw

/*! rst
Deletes the placeable's inventory on close with a small fire effect.

Scripts
~~~~~~~

:ev:`OnClose`: :file:`fw_event`

:ev:`OnUserDefined`: :file:`fd_plc_trash`
*/


#include "fi_inventory"
#include "fi_events"


void main()
{
  if (GetEvent() != EVENT_OBJECT_CLOSED)
    return;

  object oTrashCan =OBJECT_SELF;

  if (GetIsObjectValid(GetFirstItemInInventory(oTrashCan)))
  {
    effect eVis   = EffectVisualEffect(VFX_IMP_FLAME_S);
    DelayCommand(0.7f, ApplyEffectToObject(DURATION_TYPE_INSTANT, eVis, oTrashCan));
  }
  DestroyInventory(OBJECT_SELF);
}
