// =============================================================================
// Framework include
// =============================================================================
// NWN Faerun Framework (c) 2024 by Julien Lecomte
// SPDX-License-Identifier: MIT
//
// This file is part of the Faerun Framework:
//   https://framework.faerun.pw
//

#include "fi_spell"


// -----------------------------------------------------------------------------

// Completly heal the user with an effect as if cast upon the oTarget
void ActionTempleHeal(object oTarget, object oSource = OBJECT_INVALID);
void ActionTempleHeal(object oTarget, object oSource = OBJECT_INVALID)
{
  effect eVisual = EffectVisualEffect(VFX_IMP_RESTORATION_GREATER);

  RemoveInvisibility(oTarget);
  RemoveNegativeEffects(oTarget, TRUE);

  if (GetRacialType(oTarget) != RACIAL_TYPE_UNDEAD)
  {
    int nHeal = GetMaxHitPoints(oTarget) - GetCurrentHitPoints(oTarget);
    effect eHeal = EffectHeal(nHeal);
    if (nHeal < 1)
      nHeal = 1;
    ApplyEffectToObject(DURATION_TYPE_INSTANT, eHeal, oTarget);
  }
  ApplyEffectToObject(DURATION_TYPE_INSTANT, eVisual, oTarget);
  // TODO: Speaker does not cast the spell, it kinda looks awful.
}
