// =============================================================================
// Framework include
// =============================================================================
// NWN Faerun Framework (c) 2024 by Julien Lecomte
// SPDX-License-Identifier: MIT
//
// This file is part of the Faerun Framework:
//   https://framework.faerun.pw
//
//! Handle PC classes


//! @brief Return name of class CLASS_TYPE_*
//! @param nClass A CLASS_TYPE_*
//! @returns 2da name of class
string GetClassName(int nClass);
string GetClassName(int nClass)
{
  string sRetVal = Get2DAString("classes", "Label", nClass);
  return (sRetVal == "" ? "None" : sRetVal);
}


//! @brief Return TRUE if creature has at least one level of said class.
//! @param oCreature The creature
//! @param nClass A CLASS_TYPE_*
//! @returns TRUE or FALSE
int GetCreatureHasClass(object oCreature, int nClass);
int GetCreatureHasClass(object oCreature, int nClass)
{
  return (GetClassByPosition(1, oCreature) == nClass)
      || (GetClassByPosition(2, oCreature) == nClass)
      || (GetClassByPosition(3, oCreature) == nClass);
}

