// =============================================================================
// Framework include
// =============================================================================
// NWN Faerun Framework (c) 2024 by Julien Lecomte
// SPDX-License-Identifier: MIT
//
// This file is part of the Faerun Framework:
//   https://framework.faerun.pw
//
//! Handle combat routines

#include "fi_console"

#include "x0_inc_generic"

#include "nwnx_creature"


const string NW_I_WAS_ATTACKED   = "NW_I_WAS_ATTACKED";   // 0
const string NW_ATTACK_MY_TARGET = "NW_ATTACK_MY_TARGET"; // 1
const string NW_I_AM_DEAD        = "NW_I_AM_DEAD";        // 2
const string NW_UNLEASH_HELL     = "NW_UNLEASH_HELL";     // 4
const string NW_CALL_TO_ARMS     = "NW_CALL_TO_ARMS";     // 6

const string LAST_TARGET         = "LAST_TARGET";


object AI_GetLastTarget(object oSelf, object oIntruder = OBJECT_INVALID);
object AI_GetLastTarget(object oSelf, object oIntruder = OBJECT_INVALID)
{
  object oTarget = oIntruder;
  if (GetIsObjectValid(oTarget))
    return oTarget;

  oTarget = GetAttackTarget();
  if (GetIsObjectValid(oTarget))
    return oTarget;

  oTarget = GetAttemptedAttackTarget();
  if (GetIsObjectValid(oTarget))
    return oTarget;

  oTarget = GetAttemptedSpellTarget();
  if (GetIsObjectValid(oTarget))
    return oTarget;

  oTarget = GetLocalObject(oSelf, LAST_TARGET);
  if (GetIsObjectValid(oTarget))
    return oTarget;

  return OBJECT_INVALID;
}


void AI_DetermineCombatRound(object oSelf, object oIntruder = OBJECT_INVALID);
void AI_DetermineCombatRound(object oSelf, object oIntruder = OBJECT_INVALID)
{
}


void AI_DetermineNormalRound(object oSelf);
void AI_DetermineNormalRound(object oSelf)
{
  // TODO: Do we see a hostile? GetIsEnemy
  // // #include "x0_i0_anims"
  // ActionRandomWalk();
  // WalkWayPoints();
}

/*
    Allows the listener to react in a manner
    consistant with the given shout but only to one
    combat shout per round
*/
void AI_RespondToShout(int nIndex, object oSelf, object oShouter, object oIntruder = OBJECT_INVALID)
{
  switch (nIndex)
  {
    case 0: // TODO: NW_I_WAS_ATTACKED:
      // GetLastHostileActor
      // GetAttemptedAttackTarget()
      // GetAttemptedSpellTarget()
      // GetIsFriend
      // RemoveAmbientSleep();
      // DetermineCombatRound(GetLastHostileActor(oShouter));
      /*
            {
                object oTarget = oIntruder;
                if(!GetIsObjectValid(oTarget))
                {
                    oTarget = GetLastHostileActor(oShouter);
                }
                if(!GetBehaviorState(NW_FLAG_BEHAVIOR_SPECIAL))
                {
                    if(!GetLevelByClass(CLASS_TYPE_COMMONER))
                    {
                        if(!GetIsObjectValid(GetAttemptedAttackTarget()) && !GetIsObjectValid(GetAttemptedSpellTarget()))
                        {
                             if(GetIsObjectValid(oTarget))
                            {
                                if(!GetIsFriend(oTarget) && GetIsFriend(oShouter))
                                {
                                    RemoveAmbientSleep();
                                    //DetermineCombatRound(oTarget);
                                    DetermineCombatRound(GetLastHostileActor(oShouter));
                                }
                            }
                        }
                    }
                    else if (GetLevelByClass(CLASS_TYPE_COMMONER, oShouter) >= 10)
                    {
                        WrapperActionAttack(GetLastHostileActor(oShouter));
                    }
                    else
                    {
                        DetermineCombatRound(oIntruder);
                    }
                }
                else
                {
                    DetermineSpecialBehavior();
                }
            }
        */
    break;
    case 1: // NW_ATTACK_MY_TARGET
      {
        if (GetIsInCombat(oSelf) || GetIsFighting(oSelf))
          return;

        object oTarget = AI_GetLastTarget(oSelf, oIntruder);
       if (!GetIsFriend(oTarget))
         return;

        SetIsTemporaryEnemy(oTarget, oSelf);
        ClearAllActions();

        LogDebug(GetObjectInfo(oSelf) + " recieves NW_ATTACK_MY_TARGET and determines combat round against " + GetObjectInfo(oTarget));
        AI_DetermineCombatRound(oSelf, oIntruder);

    }
    break;

  case 4: // TODO: NW_UNLEASH_HELL
    break;

  case 6: // TODO: CALL_TO_ARMS
    break;
  }
}

// void main(){}
