// =============================================================================
// Framework include
// =============================================================================
// NWN Faerun Framework (c) 2024 by Julien Lecomte
// SPDX-License-Identifier: MIT
//
// This file is part of the Faerun Framework:
//   https://framework.faerun.pw
//


#include "x2_inc_switches"

// -----------------------------------------------------------------------------
const string SCRIPT_FW_EVT_SPELLHOOK = "fw_evt_spellhook";
const string SCRIPT_FW_EVT_SUBSCRIBE = "fw_evt_subscribe";
const string SCRIPT_FW_EVT_NWN       = "fw_evt_nwn";
const string SCRIPT_FW_EVT_NWNX      = "fw_evt_nwnx";

const int TLK_OFFSET = 16777216;

// Name is "Remains", Tag="BodyBag" whatever the corpse type.
const string TAG_BODY_BAG = "BodyBag";

// -----------------------------------------------------------------------------

// (int)
// Used to convey an amount
const string AMOUNT = "AMOUNT";

// (string)
// Time when the module itself started, in seconds starting from Jan 1, 1970
const string MODULE_START_TIMESTAMP = "MODULE_START_TIMESTAMP";

// (int)
// Used to send feedback to PC when interacting with placeable/trigger
// cf. nw_all_feedback
const string NW_L_FEEDBACK = "NW_L_FEEDBACK";

// (int)
// Environment variable that can be defined before
const string NWN_DEBUG = "NWN_DEBUG";

// (int)
// Export rst files if NWNX_File also exists and if in NWN_DEBUG mode.
const string NWN_EXPORT = "NWN_EXPORT";

// (string)
// Name of the script to handle no event
const string SCRIPT_NULL_EVENT = "fw_null";

// (string)
// Name of the script to handle any event
const string SCRIPT_FW_EVENT = "fw_event";

// (location)
// Where the NPC spawned
const string SPAWN_LOCATION = "SPAWN_LOCATION";

// (string)
// Time when the server started, in seconds starting from Jan 1, 1970
const string SERVER_START_TIMESTAMP = "SERVER_START_TIMESTAMP";

// (int)
// Dynamically created store that contains all custom items.
const string STORE_ALL_ITEMS = "STORE_ALL_ITEMS";

// (string)
// Used to convery a mathematical operation (>, <, >=, <=, !=, ==)
const string OP = "OP";

// (int)
// Used to convey an amount of gold
const string PRICE = "PRICE";

// (string)
// A resref
const string RESREF = "RESREF";

// (string)
// Used to pass values between scripts
const string RETVAL = "RETVAL";

// (string)
// Used as a variable name in conversations
const string WAYPOINT = "WAYPOINT";

// void main() {}

