// =============================================================================
// Framework include
// =============================================================================
// NWN Faerun Framework (c) 2024 by Julien Lecomte
// SPDX-License-Identifier: MIT
//
// This file is part of the Faerun Framework:
//   https://framework.faerun.pw
//
//
// Sortable

#include "x2_inc_switches"


const int EVENT_ITEM_ACQUIRE   = X2_ITEM_EVENT_ACQUIRE;
const int EVENT_ITEM_ACTIVATE  = X2_ITEM_EVENT_ACTIVATE;
const int EVENT_ITEM_EQUIP     = X2_ITEM_EVENT_EQUIP;
const int EVENT_ITEM_UNACQUIRE = X2_ITEM_EVENT_UNACQUIRE;
const int EVENT_ITEM_UNEQUIP   = X2_ITEM_EVENT_UNEQUIP;

const int EVENT_AREA_CREATED                      = 10001; // Called after creation
const int EVENT_AREA_DESTROY_BEFORE               = 10002; // Called before destruction
const int EVENT_AREA_ENTER                        = 10003;
const int EVENT_AREA_ENTER_BEFORE                 = 10004;
const int EVENT_AREA_ENTER_ONCE                   = 10005; // Called once per area
const int EVENT_AREA_EXIT                         = 10006;
const int EVENT_AREA_HEARTBEAT                    = 10007;
const int EVENT_AREA_SEND_AFTER                   = 10008;

const int EVENT_CALENDAR_DAY                      = 10301;
const int EVENT_CALENDAR_HOUR                     = 10302;
const int EVENT_CLIENT_CONNECT_AFTER              = 10303;
const int EVENT_CLIENT_DISCONNECT_BEFORE          = 10304;
const int EVENT_CLIENT_ENTER                      = 10305;
const int EVENT_CLIENT_ENTER_ONCE                 = 10306;
const int EVENT_CLIENT_LEAVE                      = 10307;
const int EVENT_CLIENT_SEND_TLK_AFTER             = 10308;
const int EVENT_CONSOLE_COMMAND                   = 10309;

const int EVENT_ENCOUNTER_ENTER                   = 10501;
const int EVENT_ENCOUNTER_EXHAUSTED               = 10502;
const int EVENT_ENCOUNTER_EXIT                    = 10503;
const int EVENT_ENCOUNTER_HEARTBEAT               = 10504;

const int EVENT_FACTION_REPUTATION_BEFORE         = 10601;

const int EVENT_ITEM_DROP_AFTER                   = 10901;
const int EVENT_ITEM_DROP_BEFORE                  = 10902;
const int EVENT_INFO_CONSOLE                      = 10903;

const int EVENT_JOURNAL_UPDATED                   = 11001;

const int EVENT_MAP_PIN_ADD_AFTER                 = 11301;
const int EVENT_MAP_PIN_CHANGE_AFTER              = 11302;
const int EVENT_MAP_PIN_DESTROY_AFTER             = 11303;
const int EVENT_MODULE_FLOATING_MINUTE            = 11304;
const int EVENT_MODULE_LOAD                       = 11305;
const int EVENT_MODULE_REALTIME_DAY               = 11306;
const int EVENT_MODULE_REALTIME_HOUR              = 11307;
const int EVENT_MODULE_REALTIME_MINUTE            = 11308;
const int EVENT_MODULE_START                      = 11309;

const int EVENT_NPC_ATTACKED                      = 11401;
const int EVENT_NPC_BLOCKED                       = 11402;
const int EVENT_NPC_DAMAGED                       = 11403;
const int EVENT_NPC_DEATH                         = 11404;
const int EVENT_NPC_DIALOGUE                      = 11405;
const int EVENT_NPC_DISTURBED                     = 11406;
const int EVENT_NPC_END_ROUND                     = 11407;
const int EVENT_NPC_HEARTBEAT                     = 11408;
const int EVENT_NPC_NOTICE                        = 11409;
const int EVENT_NPC_RESTED                        = 11410;
const int EVENT_NPC_SPAWN                         = 11411;
const int EVENT_NPC_SPELL_CAST_AT                 = 11412;
const int EVENT_NUI                               = 11413;

const int EVENT_OBJECT_ATTACKED                   = 11501;
const int EVENT_OBJECT_CREATED                    = 11502;
const int EVENT_OBJECT_CLICK                      = 11503;
const int EVENT_OBJECT_CLOSED                     = 11504;
const int EVENT_OBJECT_DAMAGED                    = 11505;
const int EVENT_OBJECT_DEATH                      = 11506;
const int EVENT_OBJECT_DISTURB_ADDED              = 11507;
const int EVENT_OBJECT_DISTURB_REMOVED            = 11508;
const int EVENT_OBJECT_DISTURB_STOLEN             = 11509;
const int EVENT_OBJECT_FAIL_TO_OPEN               = 11510;
const int EVENT_OBJECT_FAIL_TO_UNLOCK             = 11511;
const int EVENT_OBJECT_HEARTBEAT                  = 11512;
const int EVENT_OBJECT_LOCKED                     = 11513;
const int EVENT_OBJECT_OPENED                     = 11514;
const int EVENT_OBJECT_REVEALED                   = 11515; // Hidden object is revealed
const int EVENT_OBJECT_TRACKED                    = 11516; // Sent when dynamic object is tracked
const int EVENT_OBJECT_TRACKED_CALENDAR_HOUR      = 11517;
const int EVENT_OBJECT_TRAP_DISARMED              = 11518;
const int EVENT_OBJECT_TRAP_DISARMED_FAILED       = 11519;
const int EVENT_OBJECT_UNLOCKED                   = 11520;
const int EVENT_OBJECT_UNTRACKED                  = 11521; // Sent when dynamic object is untracked
const int EVENT_OBJECT_USED                       = 11522;

const int EVENT_PLAYER_CHAT                       = 11601;
const int EVENT_PLAYER_CHAT_AFTER                 = 11602;
const int EVENT_PLAYER_CHAT_BEFORE                = 11603;
const int EVENT_PLAYER_CHAT_HELP                  = 11604;
const int EVENT_PLAYER_DEATH                      = 11605;
const int EVENT_PLAYER_DYING                      = 11606;
const int EVENT_PLAYER_ELC_VALIDATE_BEFORE        = 11607;
const int EVENT_PLAYER_GUIEVENT_EFFECTICON_CLICK  = 11608;
const int EVENT_PLAYER_HEARTBEAT                  = 11609;
const int EVENT_PLAYER_LEVELDOWN_AFTER            = 11610;
const int EVENT_PLAYER_LEVELUP                    = 11611;
const int EVENT_PLAYER_LEVELUP_BEFORE             = 11612;
const int EVENT_PLAYER_MAY_LEVELUP                = 11613; // Player has gained enough XP to level up.
const int EVENT_PLAYER_NOTICE                     = 11614;
const int EVENT_PLAYER_RAISED                     = 11615;
const int EVENT_PLAYER_RESPAWN                    = 11616;
const int EVENT_PLAYER_RESSURECTED                = 11617;
const int EVENT_PLAYER_REST_CANCELLED             = 11618; // REST_EVENTTYPE_REST_CANCELLED
const int EVENT_PLAYER_REST_FINISHED              = 11619; // REST_EVENTTYPE_REST_FINISHED
const int EVENT_PLAYER_REST_STARTED               = 11620; // REST_EVENTTYPE_REST_STARTED
const int EVENT_PLAYER_SAVE_AFTER                 = 11621;
const int EVENT_PLAYER_SAVE_BEFORE                = 11622;
const int EVENT_PLAYER_TARGET                     = 11623;
const int EVENT_PLAYER_TILE_ACTION                = 11624;

const int EVENT_REGISTER                          = 11801;
const int EVENT_REGISTER_DISABLED                 = 11806; // TODO
const int EVENT_REPUTATION_CHANGE_BEFORE          = 11802;
const int EVENT_RESOURCE_ADDED                    = 11803;
const int EVENT_RESOURCE_MODIFIED                 = 11804;
const int EVENT_RESOURCE_REMOVED                  = 11805;

const int EVENT_STORE_CLOSE                       = 11901;
const int EVENT_STORE_OPEN                        = 11902;
const int EVENT_STORE_SELL_BEFORE                 = 11903;
const int EVENT_STORE_SELL_AFTER                  = 11904;

const int EVENT_TRAP_TRIGGERED                    = 12001;
const int EVENT_TRIGGER_CLICK                     = 12002;
const int EVENT_TRIGGER_DISARM                    = 12003;
const int EVENT_TRIGGER_ENTER                     = 12004;
const int EVENT_TRIGGER_EXIT                      = 12006;
const int EVENT_TRIGGER_HEARTBEAT                 = 12007;
const int EVENT_TRIGGER_TRIGGERED                 = 12008;
