// =============================================================================
// Framework include
// =============================================================================
// NWN Faerun Framework (c) 2024 by Julien Lecomte
// SPDX-License-Identifier: MIT
//
// This file is part of the Faerun Framework:
//   https://framework.faerun.pw
//
// Sortable
//
//! Return constant names as strings.


#include "fi_events_const"


//! @brief Get string representation of the event EVENT_*
//! param nEvent The event id
string GetEventName(int nEvent);
string GetEventName(int nEvent)
{
  switch (nEvent)
  {
    case EVENT_AREA_CREATED:        return "EVENT_AREA_CREATED";
    case EVENT_AREA_DESTROY_BEFORE: return "EVENT_AREA_DESTROY_BEFORE";
    case EVENT_AREA_ENTER:          return "EVENT_AREA_ENTER";
    case EVENT_AREA_ENTER_BEFORE:   return "EVENT_AREA_ENTER_BEFORE";
    case EVENT_AREA_ENTER_ONCE:     return "EVENT_AREA_ENTER_ONCE";
    case EVENT_AREA_EXIT:           return "EVENT_AREA_EXIT";
    case EVENT_AREA_HEARTBEAT:      return "EVENT_AREA_HEARTBEAT";
    case EVENT_AREA_SEND_AFTER:     return "EVENT_AREA_SEND_AFTER";

    case EVENT_CALENDAR_DAY:             return "EVENT_CALENDAR_DAY";
    case EVENT_CALENDAR_HOUR:            return "EVENT_CALENDAR_HOUR";
    case EVENT_CLIENT_CONNECT_AFTER:     return "EVENT_CLIENT_CONNECT_AFTER";
    case EVENT_CLIENT_DISCONNECT_BEFORE: return "EVENT_CLIENT_DISCONNECT_BEFORE";
    case EVENT_CLIENT_ENTER:             return "EVENT_CLIENT_ENTER";
    case EVENT_CLIENT_ENTER_ONCE:        return "EVENT_CLIENT_ENTER_ONCE";
    case EVENT_CLIENT_LEAVE:             return "EVENT_CLIENT_LEAVE";
    case EVENT_CLIENT_SEND_TLK_AFTER:    return "EVENT_CLIENT_SEND_TLK_AFTER";
    case EVENT_CONSOLE_COMMAND:          return "EVENT_CONSOLE_COMMAND";

    case EVENT_ENCOUNTER_ENTER:     return "EVENT_ENCOUNTER_ENTER";
    case EVENT_ENCOUNTER_EXHAUSTED: return "EVENT_ENCOUNTER_EXHAUSTED";
    case EVENT_ENCOUNTER_EXIT:      return "EVENT_ENCOUNTER_EXIT";
    case EVENT_ENCOUNTER_HEARTBEAT: return "EVENT_ENCOUNTER_HEARTBEAT";

    case EVENT_FACTION_REPUTATION_BEFORE: return "EVENT_FACTION_REPUTATION_BEFORE";

    case EVENT_ITEM_ACQUIRE:     return "EVENT_ITEM_ACQUIRE";
    case EVENT_ITEM_ACTIVATE:    return "EVENT_ITEM_ACTIVATE";
    case EVENT_ITEM_DROP_AFTER:  return "EVENT_ITEM_DROP_AFTER";
    case EVENT_ITEM_DROP_BEFORE: return "EVENT_ITEM_DROP_BEFORE";
    case EVENT_ITEM_EQUIP:       return "EVENT_ITEM_EQUIP";
    case EVENT_ITEM_UNACQUIRE:   return "EVENT_ITEM_UNACQUIRE";
    case EVENT_ITEM_UNEQUIP:     return "EVENT_ITEM_UNEQUIP";
    case EVENT_INFO_CONSOLE:     return "EVENT_INFO_CONSOLE";

    case EVENT_JOURNAL_UPDATED:  return "EVENT_JOURNAL_UPDATED";

    case EVENT_MAP_PIN_ADD_AFTER:     return "EVENT_MAP_PIN_ADD_AFTER";
    case EVENT_MAP_PIN_CHANGE_AFTER:  return "EVENT_MAP_PIN_CHANGE_AFTER";
    case EVENT_MAP_PIN_DESTROY_AFTER: return "EVENT_MAP_PIN_DESTROY_AFTER";
    case EVENT_MODULE_LOAD:           return "EVENT_MODULE_LOAD";
    case EVENT_MODULE_START:          return "EVENT_MODULE_START";

    case EVENT_NPC_ATTACKED:      return "EVENT_NPC_ATTACKED";
    case EVENT_NPC_BLOCKED:       return "EVENT_NPC_BLOCKED";
    case EVENT_NPC_DAMAGED:       return "EVENT_NPC_DAMAGED";
    case EVENT_NPC_DEATH:         return "EVENT_NPC_DEATH";
    case EVENT_NPC_DIALOGUE:      return "EVENT_NPC_DIALOGUE";
    case EVENT_NPC_DISTURBED:     return "EVENT_NPC_DISTURBED";
    case EVENT_NPC_END_ROUND:     return "EVENT_NPC_END_ROUND";
    case EVENT_NPC_HEARTBEAT:     return "EVENT_NPC_HEARTBEAT";
    case EVENT_NPC_NOTICE:        return "EVENT_NPC_NOTICE";
    case EVENT_NPC_RESTED:        return "EVENT_NPC_RESTED";
    case EVENT_NPC_SPAWN:         return "EVENT_NPC_SPAWN";
    case EVENT_NPC_SPELL_CAST_AT: return "EVENT_NPC_SPELL_CAST_AT";
    case EVENT_NUI:               return "EVENT_NUI";

    case EVENT_OBJECT_ATTACKED:              return "EVENT_OBJECT_ATTACKED";
    case EVENT_OBJECT_CLICK:                 return "EVENT_OBJECT_CLICK";
    case EVENT_OBJECT_CLOSED:                return "EVENT_OBJECT_CLOSED";
    case EVENT_OBJECT_CREATED:               return "EVENT_OBJECT_CREATED";
    case EVENT_OBJECT_DAMAGED:               return "EVENT_OBJECT_DAMAGED";
    case EVENT_OBJECT_DEATH:                 return "EVENT_OBJECT_DEATH";
    case EVENT_OBJECT_DISTURB_ADDED:         return "EVENT_OBJECT_DISTURB_ADDED";
    case EVENT_OBJECT_DISTURB_REMOVED:       return "EVENT_OBJECT_DISTURB_REMOVED";
    case EVENT_OBJECT_DISTURB_STOLEN:        return "EVENT_OBJECT_DISTURB_STOLEN";
    case EVENT_OBJECT_FAIL_TO_OPEN:          return "EVENT_OBJECT_FAIL_TO_OPEN";
    case EVENT_OBJECT_HEARTBEAT:             return "EVENT_OBJECT_HEARTBEAT";
    case EVENT_OBJECT_LOCKED:                return "EVENT_OBJECT_LOCKED";
    case EVENT_OBJECT_OPENED:                return "EVENT_OBJECT_OPENED";
    case EVENT_OBJECT_REVEALED:              return "EVENT_OBJECT_REVEALED";
    case EVENT_OBJECT_TRACKED:               return "EVENT_OBJECT_TRACKED";
    case EVENT_OBJECT_TRACKED_CALENDAR_HOUR: return "EVENT_OBJECT_TRACKED_CALENDAR_HOUR";
    case EVENT_OBJECT_UNLOCKED:              return "EVENT_OBJECT_UNLOCKED";
    case EVENT_OBJECT_UNTRACKED:             return "EVENT_OBJECT_UNTRACKED";
    case EVENT_OBJECT_USED:                  return "EVENT_OBJECT_USED";

    case EVENT_PLAYER_CHAT:                return "EVENT_PLAYER_CHAT";
    case EVENT_PLAYER_CHAT_AFTER:          return "EVENT_PLAYER_CHAT_AFTER";
    case EVENT_PLAYER_CHAT_BEFORE:         return "EVENT_PLAYER_CHAT_BEFORE";
    case EVENT_PLAYER_CHAT_HELP:           return "EVENT_PLAYER_CHAT_HELP";
    case EVENT_PLAYER_DEATH:               return "EVENT_PLAYER_DEATH";
    case EVENT_PLAYER_DYING:               return "EVENT_PLAYER_DYING";
    case EVENT_PLAYER_ELC_VALIDATE_BEFORE: return "EVENT_PLAYER_ELC_VALIDATE_BEFORE";
    case EVENT_PLAYER_HEARTBEAT:           return "EVENT_PLAYER_HEARTBEAT";
    case EVENT_PLAYER_LEVELDOWN_AFTER:     return "EVENT_PLAYER_LEVELDOWN_AFTER";
    case EVENT_PLAYER_LEVELUP:             return "EVENT_PLAYER_LEVELUP";
    case EVENT_PLAYER_LEVELUP_BEFORE:      return "EVENT_PLAYER_LEVELUP_BEFORE";
    case EVENT_PLAYER_MAY_LEVELUP:         return "EVENT_PLAYER_MAY_LEVELUP";
    case EVENT_PLAYER_NOTICE:              return "EVENT_PLAYER_NOTICE";
    case EVENT_PLAYER_RAISED:              return "EVENT_PLAYER_RAISED";
    case EVENT_PLAYER_RESPAWN:             return "EVENT_PLAYER_RESPAWN";
    case EVENT_PLAYER_RESSURECTED:         return "EVENT_PLAYER_RESSURECTED";
    case EVENT_PLAYER_REST_STARTED:        return "EVENT_PLAYER_REST_STARTED";
    case EVENT_PLAYER_SAVE_AFTER:          return "EVENT_PLAYER_SAVE_AFTER";
    case EVENT_PLAYER_SAVE_BEFORE:         return "EVENT_PLAYER_SAVE_BEFORE";

    case EVENT_MODULE_FLOATING_MINUTE:   return "EVENT_MODULE_FLOATING_MINUTE";
    case EVENT_MODULE_REALTIME_DAY:      return "EVENT_MODULE_REALTIME_DAY";
    case EVENT_MODULE_REALTIME_HOUR:     return "EVENT_MODULE_REALTIME_HOUR";
    case EVENT_MODULE_REALTIME_MINUTE:   return "EVENT_MODULE_REALTIME_MINUTE";
    case EVENT_REGISTER:                 return "EVENT_REGISTER";
    case EVENT_REPUTATION_CHANGE_BEFORE: return "EVENT_REPUTATION_CHANGE_BEFORE";
    case EVENT_RESOURCE_ADDED:           return "EVENT_RESOURCE_ADDED";
    case EVENT_RESOURCE_MODIFIED:        return "EVENT_RESOURCE_MODIFIED";
    case EVENT_RESOURCE_REMOVED:         return "EVENT_RESOURCE_REMOVED";

    case EVENT_STORE_CLOSE:       return "EVENT_STORE_CLOSE";
    case EVENT_STORE_OPEN:        return "EVENT_STORE_OPEN";
    case EVENT_STORE_SELL_AFTER:  return "EVENT_STORE_SELL_AFTER";
    case EVENT_STORE_SELL_BEFORE: return "EVENT_STORE_SELL_BEFORE";

    case EVENT_TRIGGER_CLICK:     return "EVENT_TRIGGER_CLICK";
    case EVENT_TRIGGER_DISARM:    return "EVENT_TRIGGER_DISARM";
    case EVENT_TRIGGER_ENTER:     return "EVENT_TRIGGER_ENTER";
    case EVENT_TRIGGER_EXIT:      return "EVENT_TRIGGER_EXIT";
    case EVENT_TRIGGER_HEARTBEAT: return "EVENT_TRIGGER_HEARTBEAT";
    case EVENT_TRIGGER_TRIGGERED: return "EVENT_TRIGGER_TRIGGERED";
  }
  return "";
}

//! @brief Get string representation of the event EVENT_* and a message if not found.
//! param nEvent The event id
string GetEventNameEx(int nEvent);
string GetEventNameEx(int nEvent)
{
  string sRetVal = GetEventName(nEvent);
  if (sRetVal != "")
    return sRetVal;
  return "UNKNOWN ('GetEventName' from 'fi_events_name.nss')";
}


// -----------------------------------------------------------------------------

//! @brief Get string representation of the event EVENT_SCRIPT_* and a message if not found.
//! param nEvent The event id
string GetEventScriptName(int nEvent);
string GetEventScriptName(int nEvent)
{
  switch (nEvent)
  {
    case EVENT_SCRIPT_AREAOFEFFECT_ON_HEARTBEAT:    return "EVENT_SCRIPT_AREAOFEFFECT_ON_HEARTBEAT";
    case EVENT_SCRIPT_AREAOFEFFECT_ON_OBJECT_ENTER: return "EVENT_SCRIPT_AREAOFEFFECT_ON_OBJECT_ENTER";
    case EVENT_SCRIPT_AREAOFEFFECT_ON_OBJECT_EXIT:  return "EVENT_SCRIPT_AREAOFEFFECT_ON_OBJECT_EXIT";
    case EVENT_SCRIPT_AREA_ON_ENTER:                return "EVENT_SCRIPT_AREA_ON_ENTER";
    case EVENT_SCRIPT_AREA_ON_EXIT:                 return "EVENT_SCRIPT_AREA_ON_EXIT";

    case EVENT_SCRIPT_CREATURE_ON_BLOCKED_BY_DOOR: return "EVENT_SCRIPT_CREATURE_ON_BLOCKED_BY_DOOR";
    case EVENT_SCRIPT_CREATURE_ON_DAMAGED:         return "EVENT_SCRIPT_CREATURE_ON_DAMAGED";
    case EVENT_SCRIPT_CREATURE_ON_DEATH:           return "EVENT_SCRIPT_CREATURE_ON_DEATH";
    case EVENT_SCRIPT_CREATURE_ON_DIALOGUE:        return "EVENT_SCRIPT_CREATURE_ON_DIALOGUE";
    case EVENT_SCRIPT_CREATURE_ON_DISTURBED:       return "EVENT_SCRIPT_CREATURE_ON_DISTURBED";
    case EVENT_SCRIPT_CREATURE_ON_END_COMBATROUND: return "EVENT_SCRIPT_CREATURE_ON_END_COMBATROUND";
    case EVENT_SCRIPT_CREATURE_ON_HEARTBEAT:       return "EVENT_SCRIPT_CREATURE_ON_HEARTBEAT";
    case EVENT_SCRIPT_CREATURE_ON_MELEE_ATTACKED:  return "EVENT_SCRIPT_CREATURE_ON_MELEE_ATTACKED";
    case EVENT_SCRIPT_CREATURE_ON_NOTICE:          return "EVENT_SCRIPT_CREATURE_ON_NOTICE";
    case EVENT_SCRIPT_CREATURE_ON_RESTED:          return "EVENT_SCRIPT_CREATURE_ON_RESTED";
    case EVENT_SCRIPT_CREATURE_ON_SPAWN_IN:        return "EVENT_SCRIPT_CREATURE_ON_SPAWN_IN";
    case EVENT_SCRIPT_CREATURE_ON_SPELLCASTAT:     return "EVENT_SCRIPT_CREATURE_ON_SPELLCASTAT";

    case EVENT_SCRIPT_DOOR_ON_CLICKED:        return "EVENT_SCRIPT_DOOR_ON_CLICKED";
    case EVENT_SCRIPT_DOOR_ON_CLOSE:          return "EVENT_SCRIPT_DOOR_ON_CLOSE";
    case EVENT_SCRIPT_DOOR_ON_DAMAGE:         return "EVENT_SCRIPT_DOOR_ON_DAMAGE";
    case EVENT_SCRIPT_DOOR_ON_DEATH:          return "EVENT_SCRIPT_DOOR_ON_DEATH";
    case EVENT_SCRIPT_DOOR_ON_DIALOGUE:       return "EVENT_SCRIPT_DOOR_ON_DIALOGUE";
    case EVENT_SCRIPT_DOOR_ON_DISARM:         return "EVENT_SCRIPT_DOOR_ON_DISARM";
    case EVENT_SCRIPT_DOOR_ON_FAIL_TO_OPEN:   return "EVENT_SCRIPT_DOOR_ON_FAIL_TO_OPEN";
    case EVENT_SCRIPT_DOOR_ON_HEARTBEAT:      return "EVENT_SCRIPT_DOOR_ON_HEARTBEAT";
    case EVENT_SCRIPT_DOOR_ON_LOCK:           return "EVENT_SCRIPT_DOOR_ON_LOCK";
    case EVENT_SCRIPT_DOOR_ON_MELEE_ATTACKED: return "EVENT_SCRIPT_DOOR_ON_MELEE_ATTACKED";
    case EVENT_SCRIPT_DOOR_ON_OPEN:           return "EVENT_SCRIPT_DOOR_ON_OPEN";
    case EVENT_SCRIPT_DOOR_ON_SPELLCASTAT:    return "EVENT_SCRIPT_DOOR_ON_SPELLCASTAT";
    case EVENT_SCRIPT_DOOR_ON_TRAPTRIGGERED:  return "EVENT_SCRIPT_DOOR_ON_TRAPTRIGGERED";
    case EVENT_SCRIPT_DOOR_ON_UNLOCK:         return "EVENT_SCRIPT_DOOR_ON_UNLOCK";

    case EVENT_SCRIPT_ENCOUNTER_ON_ENCOUNTER_EXHAUSTED: return "EVENT_SCRIPT_ENCOUNTER_ON_ENCOUNTER_EXHAUSTED";
    case EVENT_SCRIPT_ENCOUNTER_ON_OBJECT_ENTER:        return "EVENT_SCRIPT_ENCOUNTER_ON_OBJECT_ENTER";
    case EVENT_SCRIPT_ENCOUNTER_ON_OBJECT_EXIT:         return "EVENT_SCRIPT_ENCOUNTER_ON_OBJECT_EXIT";
    case EVENT_SCRIPT_ENCOUNTER_ON_USER_DEFINED_EVENT:  return "EVENT_SCRIPT_ENCOUNTER_ON_USER_DEFINED_EVENT";

    case EVENT_SCRIPT_MODULE_ON_ACQUIRE_ITEM:           return "EVENT_SCRIPT_MODULE_ON_ACQUIRE_ITEM";
    case EVENT_SCRIPT_MODULE_ON_ACTIVATE_ITEM:          return "EVENT_SCRIPT_MODULE_ON_ACTIVATE_ITEM";
    case EVENT_SCRIPT_MODULE_ON_CLIENT_ENTER:           return "EVENT_SCRIPT_MODULE_ON_CLIENT_ENTER";
    case EVENT_SCRIPT_MODULE_ON_CLIENT_EXIT:            return "EVENT_SCRIPT_MODULE_ON_CLIENT_EXIT";
    case EVENT_SCRIPT_MODULE_ON_EQUIP_ITEM:             return "EVENT_SCRIPT_MODULE_ON_EQUIP_ITEM";
    case EVENT_SCRIPT_MODULE_ON_HEARTBEAT:              return "EVENT_SCRIPT_MODULE_ON_HEARTBEAT";
    case EVENT_SCRIPT_MODULE_ON_LOSE_ITEM:              return "EVENT_SCRIPT_MODULE_ON_LOSE_ITEM";
    case EVENT_SCRIPT_MODULE_ON_MODULE_LOAD:            return "EVENT_SCRIPT_MODULE_ON_MODULE_LOAD";
    case EVENT_SCRIPT_MODULE_ON_MODULE_START:           return "EVENT_SCRIPT_MODULE_ON_MODULE_START";
    case EVENT_SCRIPT_MODULE_ON_NUI_EVENT:              return "EVENT_SCRIPT_MODULE_ON_NUI_EVENT";
    case EVENT_SCRIPT_MODULE_ON_PLAYER_CANCEL_CUTSCENE: return "EVENT_SCRIPT_MODULE_ON_PLAYER_CANCEL_CUTSCENE";
    case EVENT_SCRIPT_MODULE_ON_PLAYER_CHAT:            return "EVENT_SCRIPT_MODULE_ON_PLAYER_CHAT";
    case EVENT_SCRIPT_MODULE_ON_PLAYER_DEATH:           return "EVENT_SCRIPT_MODULE_ON_PLAYER_DEATH";
    case EVENT_SCRIPT_MODULE_ON_PLAYER_DYING:           return "EVENT_SCRIPT_MODULE_ON_PLAYER_DYING";
    case EVENT_SCRIPT_MODULE_ON_PLAYER_GUIEVENT:        return "EVENT_SCRIPT_MODULE_ON_PLAYER_GUIEVENT";
    case EVENT_SCRIPT_MODULE_ON_PLAYER_LEVEL_UP:        return "EVENT_SCRIPT_MODULE_ON_PLAYER_LEVEL_UP";
    case EVENT_SCRIPT_MODULE_ON_PLAYER_REST:            return "EVENT_SCRIPT_MODULE_ON_PLAYER_REST";
    case EVENT_SCRIPT_MODULE_ON_PLAYER_TARGET:          return "EVENT_SCRIPT_MODULE_ON_PLAYER_TARGET";
    case EVENT_SCRIPT_MODULE_ON_PLAYER_TILE_ACTION:     return "EVENT_SCRIPT_MODULE_ON_PLAYER_TILE_ACTION";
    case EVENT_SCRIPT_MODULE_ON_RESPAWN_BUTTON_PRESSED: return "EVENT_SCRIPT_MODULE_ON_RESPAWN_BUTTON_PRESSED";
    case EVENT_SCRIPT_MODULE_ON_UNEQUIP_ITEM:           return "EVENT_SCRIPT_MODULE_ON_UNEQUIP_ITEM";
    case EVENT_SCRIPT_MODULE_ON_USER_DEFINED_EVENT:     return "EVENT_SCRIPT_MODULE_ON_USER_DEFINED_EVENT";

    case EVENT_SCRIPT_PLACEABLE_ON_CLOSED:             return "EVENT_SCRIPT_PLACEABLE_ON_CLOSED";
    case EVENT_SCRIPT_PLACEABLE_ON_DAMAGED:            return "EVENT_SCRIPT_PLACEABLE_ON_DAMAGED";
    case EVENT_SCRIPT_PLACEABLE_ON_DEATH:              return "EVENT_SCRIPT_PLACEABLE_ON_DEATH";
    case EVENT_SCRIPT_PLACEABLE_ON_DIALOGUE:           return "EVENT_SCRIPT_PLACEABLE_ON_DIALOGUE";
    case EVENT_SCRIPT_PLACEABLE_ON_DISARM:             return "EVENT_SCRIPT_PLACEABLE_ON_DISARM";
    case EVENT_SCRIPT_PLACEABLE_ON_HEARTBEAT:          return "EVENT_SCRIPT_PLACEABLE_ON_HEARTBEAT";
    case EVENT_SCRIPT_PLACEABLE_ON_INVENTORYDISTURBED: return "EVENT_SCRIPT_PLACEABLE_ON_INVENTORYDISTURBED";
    case EVENT_SCRIPT_PLACEABLE_ON_LEFT_CLICK:         return "EVENT_SCRIPT_PLACEABLE_ON_LEFT_CLICK";
    case EVENT_SCRIPT_PLACEABLE_ON_LOCK:               return "EVENT_SCRIPT_PLACEABLE_ON_LOCK";
    case EVENT_SCRIPT_PLACEABLE_ON_MELEEATTACKED:      return "EVENT_SCRIPT_PLACEABLE_ON_MELEEATTACKED";
    case EVENT_SCRIPT_PLACEABLE_ON_OPEN:               return "EVENT_SCRIPT_PLACEABLE_ON_OPEN";
    case EVENT_SCRIPT_PLACEABLE_ON_SPELLCASTAT:        return "EVENT_SCRIPT_PLACEABLE_ON_SPELLCASTAT";
    case EVENT_SCRIPT_PLACEABLE_ON_TRAPTRIGGERED:      return "EVENT_SCRIPT_PLACEABLE_ON_TRAPTRIGGERED";
    case EVENT_SCRIPT_PLACEABLE_ON_UNLOCK:             return "EVENT_SCRIPT_PLACEABLE_ON_UNLOCK";
    case EVENT_SCRIPT_PLACEABLE_ON_USED:               return "EVENT_SCRIPT_PLACEABLE_ON_USED";

    case EVENT_SCRIPT_STORE_ON_CLOSE: return "EVENT_SCRIPT_STORE_ON_CLOSE";
    case EVENT_SCRIPT_STORE_ON_OPEN:  return "EVENT_SCRIPT_STORE_ON_OPEN";

    case EVENT_SCRIPT_TRIGGER_ON_CLICKED:       return "EVENT_SCRIPT_TRIGGER_ON_CLICKED";
    case EVENT_SCRIPT_TRIGGER_ON_DISARMED:      return "EVENT_SCRIPT_TRIGGER_ON_DISARMED";
    case EVENT_SCRIPT_TRIGGER_ON_HEARTBEAT:     return "EVENT_SCRIPT_TRIGGER_ON_HEARTBEAT";
    case EVENT_SCRIPT_TRIGGER_ON_OBJECT_ENTER:  return "EVENT_SCRIPT_TRIGGER_ON_OBJECT_ENTER";
    case EVENT_SCRIPT_TRIGGER_ON_OBJECT_EXIT:   return "EVENT_SCRIPT_TRIGGER_ON_OBJECT_EXIT";
    case EVENT_SCRIPT_TRIGGER_ON_TRAPTRIGGERED: return "EVENT_SCRIPT_TRIGGER_ON_TRAPTRIGGERED";
  }
  return "UNKNOWN (`GetEventScriptName` in fi_events_name.nss)";
}
// void main() {}
