// =============================================================================
// Framework include
// =============================================================================
// NWN Faerun Framework (c) 2024 by Julien Lecomte
// SPDX-License-Identifier: MIT
//
// This file is part of the Faerun Framework:
//   https://framework.faerun.pw
//
//
// https://nwn.wiki/display/NWN1/Journal+Editor
//


#include "fi_events"

const string NW_JOURNAL_ENTRY = "NW_JOURNAL_ENTRY";
const string NW_JOURNAL_DATE  = "NW_JOURNAL_DATE";
const string NW_JOURNAL_TIME  = "NW_JOURNAL_TIME";


// -----------------------------------------------------------------------------

// Add a journal quest entry to oCreature.
// - szPlotID: the plot identifier used in the toolset's Journal Editor
// - nState: the state of the plot as seen in the toolset's Journal Editor
// - oCreature
// - bAllPartyMembers: If this is TRUE, the entry will show up in the journal of
//   everyone in the party
// - bAllPlayers: If this is TRUE, the entry will show up in the journal of
//   everyone in the world
// - bAllowOverrideHigher: If this is TRUE, you can set the state to a lower
//   number than the one it is currently on
void AddJournalQuestEntryEx(string sCategoryTag, int nEntryID, object oCreature, int bAllPartyMembers = FALSE, int bAllPlayers = FALSE, int bAllowOverrideHigher = TRUE);
void AddJournalQuestEntryEx(string sCategoryTag, int nEntryID, object oCreature, int bAllPartyMembers = TRUE, int bAllPlayers = FALSE, int bAllowOverrideHigher = TRUE)
{
  AddJournalQuestEntry(sCategoryTag, nEntryID, oCreature, bAllPartyMembers, bAllPlayers, bAllowOverrideHigher);
  BroadcastEvent(EVENT_JOURNAL_UPDATED, oCreature);
}

