// =============================================================================
// Framework include
// =============================================================================
// NWN Faerun Framework (c) 2024 by Julien Lecomte
// SPDX-License-Identifier: MIT
//
// This file is part of the Faerun Framework:
//   https://framework.faerun.pw
//

#include "fi_console"

struct stPartyStats
{
  int nPartySize;
  int nPartyLevel;
  int nPartyLevelSqSum;
  int nPartyLevelMin;
  int nPartyLevelMax;
  float fWeightedPartyAvg;
  float fWeightedPartyLevel;
};


// struct stPartyStats GetPartyStats(object oPC, int bSameArea, bIsAlive);
struct stPartyStats GetPartyStats(object oPC);
struct stPartyStats GetPartyStats(object oPC)
{
  struct stPartyStats stStats;
  stStats.nPartyLevelMin   = 41;
  stStats.nPartyLevelMax   = -1;

  object oMember = GetFirstFactionMember(oPC, TRUE);
  while (GetIsPC(oMember))
  {
    int nLevel = GetHitDice(oMember);

    stStats.nPartySize += 1;
    stStats.nPartyLevel += nLevel;
    stStats.nPartyLevelSqSum += nLevel * nLevel;
    stStats.nPartyLevelMin = (nLevel < stStats.nPartyLevelMin) ? nLevel : stStats.nPartyLevelMin;
    stStats.nPartyLevelMax = (nLevel > stStats.nPartyLevelMax) ? nLevel : stStats.nPartyLevelMax;

    oMember = GetNextFactionMember(oPC, TRUE);
  }

  stStats.fWeightedPartyAvg = IntToFloat(stStats.nPartyLevelSqSum) / IntToFloat(stStats.nPartyLevel);
  stStats.fWeightedPartyLevel = stStats.fWeightedPartyAvg * stStats.nPartySize;
  return stStats;
}
