// =============================================================================
// Framework unit
// =============================================================================
// NWN Faerun Framework (c) 2024 by Julien Lecomte
// SPDX-License-Identifier: MIT
//
// This file is part of the Faerun Framework:
//   https://framework.faerun.pw

/*! rst
Add console commands: ``clear`` and ``cls``
*/


#include "fi_console"
#include "fi_events"


// -----------------------------------------------------------------------------
void OnCommand();
void OnCommand()
{
  ConsoleClearScreen();
}


// =============================================================================
void main()
{
  int nEvent = GetEvent();

  switch (nEvent)
  {
    case EVENT_REGISTER:
      RegisterServerConsoleCommand("clear");
      RegisterServerConsoleCommand("cls");
      RegisterEvent(EVENT_CONSOLE_COMMAND);
      return;

    case EVENT_CONSOLE_COMMAND: OnCommand(); return;
  }
}
