// =============================================================================
// Framework fix: Fix Trackless Step for underground natural areas
// =============================================================================
// NWN Faerun Framework (c) 2024 by Julien Lecomte
// SPDX-License-Identifier: MIT
//
// This file is part of the Faerun Framework:
//   https://framework.faerun.pw

/*! rst
Fix Trackless Step feat so it works in underground natural areas (eg: Caves).
*/


#include "fi_events"

#include "nwnx_skillranks"


// =============================================================================
void main()
{
  if (GetEvent() != EVENT_REGISTER)
    return;

  struct NWNX_SkillRanks_SkillFeat skillFeat = NWNX_SkillRanks_GetSkillFeat(SKILL_HIDE, FEAT_TRACKLESS_STEP);
  skillFeat.iAreaFlagsForbidden &= ~(0x2);
  NWNX_SkillRanks_SetSkillFeat(skillFeat);
  skillFeat.iSkill = SKILL_MOVE_SILENTLY;
  NWNX_SkillRanks_SetSkillFeat(skillFeat);
}
