// =============================================================================
// Framework unit
// =============================================================================
// NWN Faerun Framework (c) 2024 by Julien Lecomte
// SPDX-License-Identifier: MIT
//
// This file is part of the Faerun Framework:
//   https://framework.faerun.pw

/*! rst
Export the PC to servervault on key moments such as resting.
*/

#include "fi_events"


// =============================================================================
void main()
{
  int nEvent = GetEvent();

  switch (nEvent)
  {
    case EVENT_REGISTER:
      RegisterEvent(EVENT_PLAYER_REST_STARTED);
      RegisterEvent(EVENT_PLAYER_LEVELUP);
      RegisterEvent(EVENT_PLAYER_DEATH);
      RegisterEvent(EVENT_PLAYER_DYING);
      RegisterEvent(EVENT_PLAYER_RESPAWN);
      RegisterEvent(EVENT_AREA_EXIT);

      RegisterEvent(EVENT_MODULE_REALTIME_HOUR);

      RegisterEvent(EVENT_PLAYER_RAISED);
      RegisterEvent(EVENT_PLAYER_RESSURECTED);
      RegisterEvent(EVENT_PLAYER_MAY_LEVELUP);
      return;

    case EVENT_PLAYER_REST_STARTED: ExportSingleCharacter(GetLastPCRested());  return;
    case EVENT_PLAYER_LEVELUP:      ExportSingleCharacter(GetPCLevellingUp()); return;
    case EVENT_PLAYER_DEATH:        ExportSingleCharacter(GetLastPlayerDied());  return;
    case EVENT_PLAYER_DYING:        ExportSingleCharacter(GetLastPlayerDying()); return;
    case EVENT_PLAYER_RESPAWN:      ExportSingleCharacter(GetLastRespawnButtonPresser()); return;
    case EVENT_AREA_EXIT:           ExportSingleCharacter(GetExitingObject()); return;

    case EVENT_MODULE_REALTIME_HOUR: ExportAllCharacters(); return; // TODO, or one by one on delay loop

    case EVENT_PLAYER_RAISED:      ExportSingleCharacter(OBJECT_SELF); return;
    case EVENT_PLAYER_RESSURECTED: ExportSingleCharacter(OBJECT_SELF); return;
    case EVENT_PLAYER_MAY_LEVELUP: ExportSingleCharacter(OBJECT_SELF); return;
  }
}
