// =============================================================================
// Framework unit
// =============================================================================
// NWN Faerun Framework (c) 2024 by Julien Lecomte
// SPDX-License-Identifier: MIT
//
// This file is part of the Faerun Framework:
//   https://framework.faerun.pw

/*! rst
Automatically explore the full area for player.

Variables
~~~~~~~~~

:ev:`EXPLORE_AREA_FOR_PLAYER`: *(int)* To be set to 1 and on area.
*/

#include "fi_events"


// (bool)
// Explore area for player on Enter
const string EXPLORE_AREA_FOR_PLAYER = "EXPLORE_AREA_FOR_PLAYER";


// =============================================================================
void main()
{
  object oArea = OBJECT_SELF;
  object oPC = GetEnteringObject();
  int nEvent = GetEvent();

  switch (nEvent)
  {
    case EVENT_REGISTER:
      RegisterEvent(EVENT_AREA_ENTER);
      return;

    case EVENT_AREA_ENTER:
      if (GetLocalInt(oArea, EXPLORE_AREA_FOR_PLAYER))
        ExploreAreaForPlayer(oArea, GetEnteringObject());
      return;
  }
}
