// =============================================================================
// Framework unit
// =============================================================================
// NWN Faerun Framework (c) 2024 by Julien Lecomte
// SPDX-License-Identifier: MIT
//
// This file is part of the Faerun Framework:
//   https://framework.faerun.pw

/*! rst
On spawn, set incorporeal creature to concealment

Variables
~~~~~~~~~

:ev:`X2_L_IS_INCORPOREAL` Make creature incorporeal
*/

// TODO: This scripts should Broadcast events

#include "fi_events"
#include "fi_spell"

#include "x2_inc_switches"


// =============================================================================
void main()
{
  int nEvent = GetEvent();
  switch (nEvent)
  {
    case EVENT_REGISTER:
      RegisterEvent(EVENT_NPC_SPAWN);
      break;

    case EVENT_NPC_SPAWN:
      if (!GetCreatureFlag(OBJECT_SELF, CREATURE_VAR_IS_INCORPOREAL))
        return;
      ApplyIncorporeal(OBJECT_SELF, 50);
      break;
  }
}
