// =============================================================================
// Framework dialog action
// =============================================================================
// NWN Faerun Framework (c) 2024 by Julien Lecomte
// SPDX-License-Identifier: MIT
//
// This file is part of the Faerun Framework:
//   https://framework.faerun.pw

/*! rst
For the price of parameter :ev:`PRICE`, heal the speaker.

Parameters
~~~~~~~~~~

:ev:`PRICE`: *(int)* Price of the action.
*/

#include "fi_action"
#include "fi_const"
#include "fi_console"


// =============================================================================
void main()
{
  object oSpeaker = GetPCSpeaker();
  int    nPrice  = StringToInt(GetScriptParam(PRICE));

  int nGold = GetGold(oSpeaker);
  if (nGold < nPrice)
    return;
  TakeGoldFromCreature(nPrice, oSpeaker, TRUE);

  ActionTempleHeal(oSpeaker, GetLastSpeaker());
}
