// =============================================================================
// Framework dialog action
// =============================================================================
// NWN Faerun Framework (c) 2024 by Julien Lecomte
// SPDX-License-Identifier: MIT
//
// This file is part of the Faerun Framework:
//   https://framework.faerun.pw
//
/*! rst
Broadcast a journal update event.

When used as a conversation "Actions Taken" script, this enables the broadcast
of a ``EVENT_JOURNAL_UPDATED`` event.

Usage required for persistent journal to function properly.

.. image:: /images/dialogs/fw_dlg_act_journal.png
*/

#include "fi_journal"


// =============================================================================
void main()
{
  object oPC = GetPCSpeaker();
  BroadcastEvent(EVENT_JOURNAL_UPDATED, oPC);
}
