// =============================================================================
// Framework dialog conditional
// =============================================================================
// NWN Faerun Framework (c) 2024 by Julien Lecomte
// SPDX-License-Identifier: MIT
//
// This file is part of the Faerun Framework:
//   https://framework.faerun.pw

/*! rst
Return TRUE or FALSE depending on the quantity of PC's level.

Parameters
~~~~~~~~~~

:ev:`OP`: operator ``=``, ``>``, ``<``, ``<=``, ``>=``, ``!=``

:ev:`LEVEL`: PC level to check
*/

#include "fi_const"
#include "fi_console"


const string LEVEL = "LEVEL";


// =============================================================================
int StartingConditional()
{
  object oSpeaker = GetPCSpeaker();
  string sOp    = GetScriptParam(OP);
  int    nLevel = StringToInt(GetScriptParam(LEVEL));

  int nHD = GetHitDice(oSpeaker);

  if (sOp == "=")
    return (nHD == nLevel);
  if (sOp == ">")
    return (nHD > nLevel);
  if (sOp == ">=")
    return (nHD >= nLevel);
  if (sOp == "<=")
    return (nHD <= nLevel);
  if (sOp == "<")
    return (nHD < nLevel);
  if (sOp == "!=")
    return (nHD != nLevel);

  LogError("fw_dlg_cnd_level: called with invalid 'OP' value");
  return FALSE;
}
