// =============================================================================
// Framework dialog conditional
// =============================================================================
// NWN Faerun Framework (c) 2024 by Julien Lecomte
// SPDX-License-Identifier: MIT
//
// This file is part of the Faerun Framework:
//   https://framework.faerun.pw

/*! rst
Roll a random number as an dialog conditional.

The random value is stored in :ev:`VALUE` on the PC.

This script always returns False.

Parameters
~~~~~~~~~~

:ev:`VALUE`: *(string)* d6() if missing, otherwise executed line. eg: "d6(3) + 2)"

Examples
~~~~~~~~

.. image:: /images/dialogs/fw_dlg_cnd_rand.png

*/


#include "fi_core"
#include "fi_console"


const string VALUE = "VALUE";


// =============================================================================
int StartingConditional()
{
  object oPC = GetLastSpeaker();
  string sValue = GetScriptParam(VALUE);

  // Generate a random value
  if (sValue == "")
    sValue = "d6()";

  int nValue = RollDiceFromString(sValue);
  SetLocalInt(oPC, VALUE, nValue);

  return FALSE;
}
