// =============================================================================
// Framework events: Any event script
// =============================================================================
// NWN Faerun Framework (c) 2024 by Julien Lecomte
// SPDX-License-Identifier: MIT
//
// This file is part of the Faerun Framework:
//   https://framework.faerun.pw
//
// Handles built-in NWN Events, and then sends them as User-Defined events to
// OBJECT_SELF and broadcasts to units that registered the event.
//
// All events for placeables, doors, triggers, etc... should be handled by this
// event handler.


#include"fi_events"

#include"nwnx_events"


// =============================================================================
void main()
{
  string sEvent = NWNX_Events_GetCurrentEvent();
  if (sEvent != "")
    ExecuteScript(SCRIPT_FW_EVT_NWNX);
  else
    ExecuteScript(SCRIPT_FW_EVT_NWN);
}
