// =============================================================================
// Framework event script
// =============================================================================
// NWN Faerun Framework (c) 2024 by Julien Lecomte
// SPDX-License-Identifier: MIT
//
// This file is part of the Faerun Framework:
//   https://framework.faerun.pw
//
// Sortable
//

#include "fi_console"
#include "fi_events"

#include "nwnx_events"


// =============================================================================
void main()
{
  object oModule = GetModule();
  string sEvent = NWNX_Events_GetCurrentEvent();

  if (FALSE) {}
  // Don't forget to update fw_evt_subscribe. fw_evt_nwnx, fi_events_const, fi_events_name
  else if (sEvent == NWNX_ON_CALENDAR_DAY)                      BroadcastEvent(EVENT_CALENDAR_DAY);
  else if (sEvent == NWNX_ON_CALENDAR_HOUR)                     BroadcastEvent(EVENT_CALENDAR_HOUR);
  else if (sEvent == NWNX_ON_CLIENT_CONNECT_AFTER)              BroadcastEvent(EVENT_CLIENT_CONNECT_AFTER);
  else if (sEvent == NWNX_ON_CLIENT_DISCONNECT_BEFORE)          BroadcastEvent(EVENT_CLIENT_DISCONNECT_BEFORE);
  else if (sEvent == NWNX_ON_ELC_VALIDATE_CHARACTER_BEFORE)     BroadcastEvent(EVENT_PLAYER_ELC_VALIDATE_BEFORE);
  else if (sEvent == NWNX_ON_INPUT_DROP_ITEM_AFTER)             BroadcastEvent(EVENT_ITEM_DROP_AFTER);
  else if (sEvent == NWNX_ON_INPUT_DROP_ITEM_BEFORE)            BroadcastEvent(EVENT_ITEM_DROP_BEFORE);
  else if (sEvent == NWNX_ON_LEVEL_DOWN_AFTER)                  BroadcastEvent(EVENT_PLAYER_LEVELUP_BEFORE);
  else if (sEvent == NWNX_ON_LEVEL_UP_BEFORE)                   BroadcastEvent(EVENT_PLAYER_LEVELUP_BEFORE);
  else if (sEvent == NWNX_ON_MAP_PIN_ADD_PIN_AFTER)             BroadcastEvent(EVENT_MAP_PIN_ADD_AFTER);
  else if (sEvent == NWNX_ON_MAP_PIN_CHANGE_PIN_AFTER)          BroadcastEvent(EVENT_MAP_PIN_CHANGE_AFTER);
  else if (sEvent == NWNX_ON_MAP_PIN_DESTROY_PIN_AFTER)         BroadcastEvent(EVENT_MAP_PIN_DESTROY_AFTER);
  else if (sEvent == NWNX_ON_RESOURCE_ADDED)                    BroadcastEvent(EVENT_RESOURCE_ADDED, oModule);
  else if (sEvent == NWNX_ON_RESOURCE_MODIFIED)                 BroadcastEvent(EVENT_RESOURCE_MODIFIED, oModule);
  else if (sEvent == NWNX_ON_RESOURCE_REMOVED)                  BroadcastEvent(EVENT_RESOURCE_REMOVED, oModule);
  else if (sEvent == NWNX_ON_SERVER_CHARACTER_SAVE_AFTER)       BroadcastEvent(EVENT_PLAYER_SAVE_AFTER);
  else if (sEvent == NWNX_ON_SERVER_CHARACTER_SAVE_BEFORE)      BroadcastEvent(EVENT_PLAYER_SAVE_BEFORE);
  else if (sEvent == NWNX_ON_SERVER_SEND_AREA_BEFORE)           BroadcastEvent(EVENT_AREA_ENTER_BEFORE);
  else if (sEvent == NWNX_ON_SET_NPC_FACTION_REPUTATION_BEFORE) BroadcastEvent(EVENT_REPUTATION_CHANGE_BEFORE);
  else if (sEvent == NWNX_ON_STORE_REQUEST_SELL_AFTER)          BroadcastEvent(EVENT_STORE_SELL_AFTER);
  else if (sEvent == NWNX_ON_STORE_REQUEST_SELL_BEFORE)         BroadcastEvent(EVENT_STORE_SELL_BEFORE);
  else if (sEvent == NWNX_ON_SET_NPC_FACTION_REPUTATION_BEFORE) BroadcastEvent(EVENT_FACTION_REPUTATION_BEFORE);
  else
    LogError("Caught " + sEvent + " but no handler. (fw_evt_nwnx.nss)");
}

