// =============================================================================
// Framework fire and forget
// =============================================================================
// NWN Faerun Framework (c) 2024 by Julien Lecomte
// SPDX-License-Identifier: MIT
//
// This file is part of the Faerun Framework:
//   https://framework.faerun.pw


#include "inc_array"

#include "fi_store"


// =============================================================================
void main()
{
  object oArea = GetFirstArea();
  while (oArea != OBJECT_INVALID)
  {
    object oStore = GetFirstObjectInArea(oArea, OBJECT_TYPE_STORE);
    while (oStore != OBJECT_INVALID)
    {
      // If already tracked, ignore
      if (Array_Contains_Obj(MOD_ARRAY_TRACKED_STORES, oStore))
      {
        oStore = GetNextObjectInArea(oArea, OBJECT_TYPE_STORE);
        continue;
      }

      // Save it in database
      Array_PushBack_Obj(MOD_ARRAY_TRACKED_STORES, oStore);

      oStore = GetNextObjectInArea(oArea, OBJECT_TYPE_STORE);
    }
    oArea = GetNextArea();
  }
}

