// =============================================================================
// Framework AI script: OnConversation
// =============================================================================
// Copyright (c) 2002 Bioware Corp.
//
// NWN Faerun Framework (c) 2024 by Julien Lecomte
// SPDX-License-Identifier: MIT
//
// This file is part of the Faerun Framework:
//   https://framework.faerun.pw
//
// cf. x2_def_attacked, nw_c2_default5

#include "nw_i0_generic"

#include "fi_events"
#include "fi_userdef"

void main()
{
  // Plot objects ignore everything
  if (GetPlotFlag(OBJECT_SELF))
    return;

  object oAttacker = GetLastAttacker();
  if (!GetIsObjectValid(oAttacker))
    return;

  // if (GetImmortal(OBJECT_SELF) && !GetIsEnemy(oAttacker))
  //   return;
  if (GetSpawnInCondition(NW_FLAG_SET_WARNINGS))
    SetSpawnInCondition(NW_FLAG_SET_WARNINGS, FALSE);
  else if (!GetIsFighting(OBJECT_SELF))
  {
    if (GetBehaviorState(NW_FLAG_BEHAVIOR_SPECIAL))
    {
      SetSummonHelpIfAttacked();
      DetermineSpecialBehavior(oAttacker);
    } else if (GetArea(oAttacker) == GetArea(OBJECT_SELF)) {
      SetSummonHelpIfAttacked();
      DetermineCombatRound(oAttacker);
    }

    SpeakString("NW_ATTACK_MY_TARGET", TALKVOLUME_SILENT_TALK);
    SpeakString("NW_I_WAS_ATTACKED", TALKVOLUME_SILENT_TALK);
  }

  if(GetSpawnInCondition(NW_FLAG_ATTACK_EVENT))
    SignalEvent(OBJECT_SELF, EventUserDefined(EVENT_ATTACKED));

  ExecuteUserDefinedScript(EVENT_NPC_ATTACKED);
  BroadcastEvent(EVENT_NPC_ATTACKED);
}
