//::///////////////////////////////////////////////
//:: Default: End of Combat Round
//:: NW_C2_DEFAULT3
//:: Copyright (c) 2008 Bioware Corp.
//:://////////////////////////////////////////////
/*
    Calls the end of combat script every round
*/
//:://////////////////////////////////////////////
//:: Created By: Preston Watamaniuk
//:: Created On: Oct 16, 2001
//:://////////////////////////////////////////////
// =============================================================================
// Framework AI script: OnCombatRound
// =============================================================================
// Copyright (c) 2002 Bioware Corp.
//
// NWN Faerun Framework (c) 2024 by Julien Lecomte
// SPDX-License-Identifier: MIT
//
// This file is part of the Faerun Framework:
//   https://framework.faerun.pw
//
// cf. x2_def_endcombat, nw_c2_default3


#include "fi_events"
#include "fi_userdef"

#include "nw_i0_generic"


void main()
{
  if (GetBehaviorState(NW_FLAG_BEHAVIOR_SPECIAL))
    DetermineSpecialBehavior();
  else if(!GetSpawnInCondition(NW_FLAG_SET_WARNINGS))
    DetermineCombatRound();

 if (GetSpawnInCondition(NW_FLAG_END_COMBAT_ROUND_EVENT))
   SignalEvent(OBJECT_SELF, EventUserDefined(1003));

  ExecuteUserDefinedScript(EVENT_NPC_END_ROUND);
  BroadcastEvent(EVENT_NPC_END_ROUND);
}




