// =============================================================================
// Framework AI script: OnConversation
// =============================================================================
// Copyright (c) 2002 Bioware Corp.
//
// NWN Faerun Framework (c) 2024 by Julien Lecomte
// SPDX-License-Identifier: MIT
//
// This file is part of the Faerun Framework:
//   https://framework.faerun.pw
//
// cf. x2_def_onconv, nw_c2_default4




#include "fi_core"
#include "fi_combat"


void StartConversation(object oTarget)
{
  // Not deaf, petrified, etc.
  if (GetIsAbleToHaveAConversation(oTarget)
      && (GetCommandable(oTarget) || GetHasEffect(EFFECT_TYPE_CHARMED)))
  {
    ClearActions(CLEAR_NW_C2_DEFAULT4_29);
    BeginConversation();
  }
}


void OnShout(int nMatch, object oTarget, object oShouter)
{
  if (!GetIsObjectValid(oShouter))
    return;

  if (GetIsPC(oShouter))
    return;

  if (!GetIsFriend(oShouter))
    return;

  AI_RespondToShout(nMatch, OBJECT_SELF, oShouter);
}


void main()
{
  // if petrified, jump out
  if (GetHasEffect(EFFECT_TYPE_PETRIFY))
    return;

  // If dead, exit directly.
  if (GetIsDead(OBJECT_SELF))
    return;

  int nMatch = GetListenPatternNumber();
  if (nMatch == -1)
  {
    StartConversation(OBJECT_SELF);
    return;
  }

  object oShouter = GetLastSpeaker();
  OnShout(nMatch, OBJECT_SELF, oShouter);
}
