// =============================================================================
// Framework AI script: OnDeath
// =============================================================================
// Copyright (c) 2002 Bioware Corp.
//
// NWN Faerun Framework (c) 2024 by Julien Lecomte
// SPDX-License-Identifier: MIT
//
// This file is part of the Faerun Framework:
//   https://framework.faerun.pw
//
// cf. x2_def_ondeath, nw_c2_default7


#include "fi_ai"


void main()
{
  object oKiller = GetLastKiller();

  SpeakString(NW_I_AM_DEAD, TALKVOLUME_SILENT_TALK);
  SpeakString(NW_ATTACK_MY_TARGET, TALKVOLUME_SILENT_TALK);

  // Ensure that heartbeat is never triggered anymore since we'll keep spawns
  // on the ground
  SetEventScript(OBJECT_SELF, EVENT_SCRIPT_CREATURE_ON_HEARTBEAT, "");

  // Set the tag to BodyBag in case it stays as a corpse so a garbage collector
  // can pick it up.
  SetTag(OBJECT_SELF, TAG_BODY_BAG);

  SetAILevel(OBJECT_SELF, AI_LEVEL_VERY_LOW);
}
