// =============================================================================
// Framework AI script: OnDisturbed
// =============================================================================
// Copyright (c) 2002 Bioware Corp.
//
// NWN Faerun Framework (c) 2024 by Julien Lecomte
// SPDX-License-Identifier: MIT
//
// This file is part of the Faerun Framework:
//   https://framework.faerun.pw
//
// cf. x2_def_ondisturb, nw_c2_default8

#include "nw_i0_generic"

#include "fi_events"
#include "fi_userdef"

void main()
{
  object oTarget = GetLastDisturbed();

  // If we've been disturbed and are not already fighting,
  // attack our disturber.
  if (GetIsObjectValid(oTarget) && !GetIsFighting(OBJECT_SELF))
    DetermineCombatRound(oTarget);

  // Send the disturbed flag if appropriate.
  if (GetSpawnInCondition(NW_FLAG_DISTURBED_EVENT))
    SignalEvent(OBJECT_SELF, EventUserDefined(EVENT_DISTURBED));

  ExecuteUserDefinedScript(EVENT_NPC_DISTURBED);
  BroadcastEvent(EVENT_NPC_DISTURBED);
}
