// =============================================================================
// Framework AI script: OnSpawn
// =============================================================================
// Copyright (c) 2002 Bioware Corp.
//
// NWN Faerun Framework (c) 2024 by Julien Lecomte
// SPDX-License-Identifier: MIT
//
// This file is part of the Faerun Framework:
//   https://framework.faerun.pw
//
// cf. x2_def_spawn, nw_c2_default9


#include "fi_combat"


void main()
{
  // Save the spawn location
  SetLocalLocation(OBJECT_SELF, "SPAWN_LOCATION", GetLocation(OBJECT_SELF));

  int nFaction = NWNX_Creature_GetFaction(OBJECT_SELF);
  switch (nFaction)
  {
    case STANDARD_FACTION_MERCHANT:
    case STANDARD_FACTION_COMMONER:
      SetListenPattern(OBJECT_SELF, NW_I_WAS_ATTACKED, 0);
      break;

    case STANDARD_FACTION_DEFENDER:
    case STANDARD_FACTION_HOSTILE:
    default:
      SetListenPattern(OBJECT_SELF, NW_I_WAS_ATTACKED, 0);
      SetListenPattern(OBJECT_SELF, NW_ATTACK_MY_TARGET, 1);
      SetListenPattern(OBJECT_SELF, NW_UNLEASH_HELL, 4);
      SetListenPattern(OBJECT_SELF, NW_CALL_TO_ARMS, 6);
      break;
  }

  object oEnemy = GetNearestSeenEnemy();
  if (GetIsObjectValid(oEnemy))
    AI_DetermineCombatRound(OBJECT_SELF, oEnemy);
  else
    AI_DetermineNormalRound(OBJECT_SELF);
}
